/*
 * Description : Fajlveg (Ctrl+Z) jelzesig szamoljuk, hogy hany:
 *               - numerikus karakter
 *               - feher karakter
 *               - mas egyeb karakter
 *               - osszesen hany karakter erkezett be
 *
 * Author      : Zoltn Furk
 *
 * Version     : 2011.01.21
 */
#include <stdio.h>
#include <ctype.h>

void main(void) {
    int szam=0, feher=0, egyeb=0;
    char c;

    printf("Kerem adjon meg karaktereket EOF -ig es a\n"
           "program megszamolja oket a megadott szempontok alapjan\n"
           "------------------------------------------------------\n"
           " - egesz szamok\n"
           " - feher karakterek\n"
           " - egyeb karakterek\n"
           " - osszesen bekert karakterek szama\n\n");

    while ((c=getchar()) != EOF) {
        if(isdigit(c))
            ++szam;
        else if(isspace(c))
            ++feher;
        else
            ++egyeb;
    }

    printf("A megadott karakterek darabszama:\n"
           "---------------------------------\n"
           " - egesz szamok    : %3d\n"
           " - feher karakterek: %3d\n"
           " - egyeb karakterek: %3d\n"
           " - osszes krakter  : %3d\n", szam, feher, egyeb, szam+feher+egyeb);

    getch();
}