/* 10_5.C: Egsz szmok tlaga, minimuma, maximuma s rendezse. */
#include <stdio.h>
#include <stdlib.h>
#include <limits.h>

/* Visszaadja a beolvasott karaktersorozat hosszt. s tmbbe olvas,
   lim a karakterlnc maximlis hossza. Az s tmbnek teht legalbb
   lim+1 mretnek kell lennie. (A lnczr '\0' karakternek is kell
   hely.) */
int getline(char s[], int lim){
	int i,c;
	for(i=0; i<lim && (c=getchar())!=EOF && c!='\n'; ++i) s[i]=c;
	s[i]='\0';
	while(c!=EOF && c!='\n') c=getchar();
	return i; }

/* A fggvny logikai vlaszt ad arra a krdsre, hogy paramtere
   formailag helyes egsz-e karakterlnc alakban. */
#define HSZ sizeof(int)/sizeof(short)*5 /* Az int max. jegyeinek szma. */
int egesze(char s[]){
	int i = 0;		/* Indexels. */
	int kezd;		/* Az els numerikus karakter indexe. */
	/* A karakterlnc elejn lev fehr karakterek tlpse: */
	while(s[i] == ' ' || s[i] == '\n' || s[i] == '\t') ++i;
	/* Az eljel tlpse: */
	if( s[i] == '+' || s[i] == '-') ++i;
	kezd = i;		/* A szmjegyek itt kezddnek. */
	/* Elrelps a kvetkez, els nem numerikus karakterre: */
	while( s[i] >= '0' && s[i] <= '9' && i - kezd < HSZ) ++i;
	/* Dnts: */
	if(kezd==i || s[i]!='\n'&&s[i]!='\t'&&s[i]!=' '&&s[i]!=0) return 0;
	else return 1; }

void rendez(int w[],int n){	/* Az n elem w egsz tmb nvekv rendezse. */
	int i,j,m;
	for(i=0;i<n-1;++i){
		for(j=i+1, m=i; j<n; ++j)
			if(w[j]<w[m]) m=j;
		if(i!=m){ j=w[i]; w[i]=w[m]; w[m]=j;} } }

#define MAX 100
#define INP 20
void main(void){
	int n=0;		/* A rendezend elemek szma. */
	char sor[INP+1];/* Input puffer. */
	int v[MAX];		/* A egsz szmokat trol tmb. */
	int min, max;	/* Minimum, maximum. */
	double atlag=0.0;	/* Az sszeg */
	int i;
	while(n<1||n>MAX){
		printf("\nHny egsz szmot rendezznk(1-%d)? ", MAX);
		getline(sor,INP);
		if(egesze(sor)) n=atoi(sor);}
	printf("\nKrem a rendezend szmokat %d s +%d kztt!\n",
			INT_MIN, INT_MAX);
	for(i=0;i<n;++i){
		printf("%4d: ",i+1);
		if(getline(sor,INP)>0 && egesze(sor)) v[i]=atoi(sor);
		else --i; }
	min=max=v[0];
	for(i=0;i<n;atlag+=v[i],++i)
		if(v[i]<min) min=v[i];
		else if(v[i]>max) max=v[i];
	printf("\nA szmsorozat\tminimuma %8d\n\t\tmaximuma %8d\n",min, max);
	printf("\t\ttlaga %13.2f\n", atlag/n);
	printf("\nA rendezett szmok:\n");
	rendez(v,n);
	for(i=0;i<n;i++)printf("%8d",v[i]);
	printf("\n"); }
