/*
 * Description : Muveletes
 *               A feladat leirasat lasd a feladat.txt fajlban.
 *
 * Author      : Zoltn Furk
 *
 * Version     : 2011.01.23
 */
#include <stdio.h>
#include <string.h>
#include <ctype.h>
#include <stdlib.h>
#include <conio.h>

int getline(char s[], int lim) {
    int i;
    char c;
    for(i=0;i<lim && (c=getchar())!='\n' && c!=EOF;++i)s[i]=c;
    s[i]='\0';
    while(c!='\n'&& c!=EOF)c=getchar();
    return i;
}

void main(void){
    char tmp[20],szamt1[6+1],szamt2[6+1];
    int i,j,eredmenyszamitas=0,vege=0,jokarakter=1,egyenl=0,osszeadas=0,minusz=0,johelyenvan1=1,johelyenvan2=1;
    int szam1=0,szam2=0;
    
    clrscr();

    printf("Kerem adjon meg egy a+b= alaku egyenletet ahol a<0 s b<100.\n"
           "------------------------------------------------------------\n");
    do {
        do {
            if(!getline(tmp,20))
                printf("Nem lehet ures sort megadni!\n");
            else if(strlen(tmp)<5)
                printf("Az egyenletnek minimum 5 karakterbol kell allnia!\n");
            else if(tmp[0]!='-')
                printf("Az egyenletnek negativ szammal kell kezdodnie!\n");
            else {
                jokarakter=1;
                osszeadas=0;
                minusz=1;
                egyenl=0;

                for (i=1; tmp[i]; ++i) {
                    switch (tmp[i]) {
                        case '+':
                            ++osszeadas;
                            break;
                        case '-':
                            ++minusz;
                            break;
                        case '=':
                            ++egyenl;
                            break;
                        default :
                            if(tmp[i]<'0' || tmp[i]>'9')
                                jokarakter=0;
                            break;
                    }
                }

                /* hibakezeles */
                if (jokarakter==0)
                    printf("Az egyenletben rossz karakter szerepel!\n");
                else if (osszeadas!=1)
                    printf("Az egyenletben egy osszeadasnak kell szerepelnie!\n");
                else if (minusz>2)
                    printf("Az egyenletben maximum 2 minusz elojel szerepelhet!\n");
                else if (egyenl!=1)
                    printf("Az egyenletben egy egyenlosegjelnek kell szerepelnie!\n");
                else if (jokarakter==1 && osszeadas==1 && minusz<3 && egyenl==1 && minusz!=0) {

                    /* jo karakterek vannak benne de a helyuk meg nem biztos */
                    johelyenvan1=1;
                    johelyenvan2=1;

                    /* elso szam vizsgalata */
                    for (i=1; tmp[i]!='+'; ++i) {
                        if (!isdigit(tmp[i])) {
                            johelyenvan1=0;
                            break;
                        }
                    }

                    /* masodik szam vizsgalata */
                    i=i+2;

                    /* ha negativ a masodik szam */
                    if (tmp[i]=='-') {
                        for (++i; tmp[i]!='='; ++i) {
                            if (!isdigit(tmp[i])) {
                                johelyenvan2=0;
                                break;
                            }
                        }
                    } else {
                        for (i=i; tmp[i]!='='; ++i) {
                            if (!isdigit(tmp[i])) {
                                johelyenvan2=0;
                                break;
                            }
                        }
                    }

                    if (tmp[(strlen(tmp)-1)] != '=')
                        printf("Az egyenlet nem tartalmazhat karaktert az '=' jel utan!\n");
                    else
                        if (johelyenvan1==1 && johelyenvan2==1 && egyenl==1)
                            vege=1;

                    if (johelyenvan1 == 0)
                        printf("Az elso szam nem megfelelo!\n");

                    if (johelyenvan2 == 0)
                        printf("A masodik szam nem megfelelo!\n");
                }
            }
        } while (!vege);

        /* elso szam tombbe masolasa majd atoi */
        for (i=0; tmp[i]!='+'; ++i)
            szamt1[i]=tmp[i];

        szamt1[i]='\0';
        szam1=atoi(szamt1);

        /* masodik szam tombbe masolasa majd atoi */
        for(j=++i; tmp[i]!='='; ++i)
            szamt2[i-j]=tmp[i];

        szamt2[i-j]='\0';
        szam2=atoi(szamt2);

        /* valtozo ertekenek vizsgalata */
        if (szam1>=0)
            printf("Az 'a' valtozora teljesulnie kell: a<0!\n");
        else if (szam2>=100)
            printf("A 'b' valtozora teljesulnie kell: b<100!\n");
        else
            eredmenyszamitas=1;

    } while (!eredmenyszamitas);

    printf("\nAZ EGYENLET VEGEREDMENYE: %d + %d = %d\n", szam1, szam2, szam1+szam2);

    getch();
}