/*
 * Description : Atlag-paritas
 *               A feladat leirasat lasd a feladat.txt fajlban.
 *
 * Author      : Zoltn Furk
 *
 * Version     : 2011.01.23
 */
#include <stdio.h>
#include <ctype.h>
#include <string.h>
#include <stdlib.h>
#include <conio.h>

enum {
    SZAMDARAB=5
};

int getline(char s[], int lim) {
    int i;
    char c;
    for(i=0;i<lim && (c=getchar())!='\n' && c!=EOF;++i)s[i]=c;
    s[i]='\0';
    while(c!='\n'&& c!=EOF)c=getchar();
    return i;
}

int egesz(char s[]){
    int i;
    i=(s[0]=='-' || s[0]=='+')?1:0;
    while(s[i]){
        if(!isdigit(s[i]))return 0;
        i++;
    }
    return 1;
}

int paros(int szam) {
    if (szam%2)
        return 0;
    return 1;
}

void main(void) {
    int szamok[SZAMDARAB];
    int i,beolvasott=0,parososszeg=0,paratlanoaazwg=0,parosok=0,paratlanok=0;
    char temp[6+1];

    clrscr ();

    printf("Szam bekeres es atlag szamitas! Adjon meg %d szamot:\n"
           "===================================================\n", SZAMDARAB);
    do {
        printf("Kerem adja meg a(z) %d. szamot:\n"
               "-------------------------------\n", beolvasott+1);
        if (!getline(temp, 6))
            printf("Nem adhat meg ures sort!\n");
        else if (strlen(temp) > 5)
            printf("Tul sok karaktert adott meg!\n");
        else if (!egesz(temp))
            printf("Nem egesz szamot adott meg!\n");
        else {
            szamok[beolvasott]=atoi(temp);

            if (szamok[beolvasott] < 1)
                printf("Pozitiv szamot adjon meg!\n");
            else
                ++beolvasott;
        }
    } while (beolvasott < SZAMDARAB);

    printf("Tartalma:\n"
           "---------\n");
    for (i=0; i<SZAMDARAB; ++i) {
        printf("%d ", szamok[i]);

        if (paros(szamok[i])) {
            parososszeg+=szamok[i];
            ++parosok;
        } else {
            paratlanoaazwg+=szamok[i];
            ++paratlanok;
        }
    }

    printf("\n\n%2d db paros szam atlaga   : %.2f\n"
               "%2d db paratlan szam atlaga: %.2f", parosok, (double)parososszeg/parosok,
                                                   paratlanok, (double)paratlanoaazwg/paratlanok);

    getch();
}