/*
 * Description : Tortes
 *               A feladat leirasat lasd a feladat.txt fajlban.
 *
 * Author      : Zoltn Furk
 *
 * Version     : 2011.01.30
 */
#include <stdio.h>
#include <string.h>
#include <conio.h>
#include <ctype.h>

#define SZAMLALO ((((b*d)/b)*a)+(((b*d)/d)*c))
#define NEVEZO   (b*d)

enum {
    MINSZAM=1,
    MAXSZAM=25,
    MAXHOSSZ=10,
    MAXEREDMENYEK=100
};

 int getline(char s[], int lim) {
    int i;
    char c;
    for(i=0;i<lim && (c=getchar())!='\n' && c!=EOF;++i)s[i]=c;
    s[i]='\0';
    while(c!='\n'&& c!=EOF)c=getchar();
    return i;
}


int egesz(char s[]){
    int i;
    i=(s[0]=='-' || s[0]=='+')?1:0;
    while(s[i]){
        if(!isdigit(s[i]))return 0;
        i++;
    }
    return 1;
}

void main(void) {
    double eredmenyek[MAXEREDMENYEK];
    int ok, vege=0, bekert=0, i;
    char tmp[MAXHOSSZ+1];
    long int a, b, c, d;

    clrscr();

    do {
        printf("Kerem adja meg 'a' erteket:\n");
        ok=0;
        do {
            if (!getline(tmp, MAXHOSSZ)) {
                printf("Ures sort utott, vege a bekeresnek!\n\n");
                vege=1;
                ok=1;
            } else if (!egesz(tmp))
                printf("Nem egesz szamot adott meg!\n");
            else {
                a=atol(tmp);

                if (a < MINSZAM)
                    printf("Minimum %d -t adjon meg!\n", MINSZAM);
                else if (a > MAXSZAM)
                    printf("Maximum %d -t adjon meg!\n", MAXSZAM);
                else
                    ok=1;
            }
        } while(!ok);

        if (!vege) {
            printf("Kerem adja meg 'b' erteket:\n");
            ok=0;
            do {
                if (!getline(tmp, MAXHOSSZ))
                    printf("Nem adhat meg ures sort!\n");
                else if (!egesz(tmp))
                    printf("Nem egesz szamot adott meg!\n");
                else {
                    b=atol(tmp);

                    if (b < MINSZAM)
                        printf("Minimum %d -t adjon meg!\n", MINSZAM);
                    else if (b > MAXSZAM)
                        printf("Maximum %d -t adjon meg!\n", MAXSZAM);
                    else
                        ok=1;
                }
            } while(!ok);

            printf("Kerem adja meg 'c' erteket:\n");
            ok=0;
            do {
                if (!getline(tmp, MAXHOSSZ))
                    printf("Nem adhat meg ures sort!\n");
                else if (!egesz(tmp))
                    printf("Nem egesz szamot adott meg!\n");
                else {
                    c=atol(tmp);

                    if (c < MINSZAM)
                        printf("Minimum %d -t adjon meg!\n", MINSZAM);
                    else if (c > MAXSZAM)
                        printf("Maximum %d -t adjon meg!\n", MAXSZAM);
                    else
                        ok=1;
                }
            } while(!ok);

            printf("Kerem adja meg 'd' erteket:\n");
            ok=0;
            do {
                if (!getline(tmp, MAXHOSSZ))
                    printf("Nem adhat meg ures sort!\n");
                else if (!egesz(tmp))
                    printf("Nem egesz szamot adott meg!\n");
                else {
                    d=atol(tmp);

                    if (d < MINSZAM)
                        printf("Minimum %d -t adjon meg!\n", MINSZAM);
                    else if (d > MAXSZAM)
                        printf("Maximum %d -t adjon meg!\n", MAXSZAM);
                    else
                        ok=1;
                }
            } while(!ok);

            eredmenyek[bekert] = (double)SZAMLALO/NEVEZO;
            printf("%ld/%ld+%ld/%ld = %ld/%ld ~ %.2f\n", a, b, c, d, SZAMLALO, NEVEZO, eredmenyek[bekert]);
            printf("%ld%%%ld=%d\n\n",SZAMLALO , NEVEZO, SZAMLALO%NEVEZO);
            ++bekert;
        }
    } while(!vege);

    if (bekert != 0) {
        printf("Az eredmenyek a megadott sorrendben:\n");

        for (i=0; i<bekert; ++i)
            printf("%.2f ", eredmenyek[i]);
    } else {
        printf("Egy tortet sem adott meg!\n");
    }

    getch();
}