/*
 * Description : Edessegek
 *               A feladat leirasat lasd a feladat.jpg fajlban.
 *
 * Author      : Zoltn Furk
 *
 * Version     : 2011.01.30
 */
#include <stdio.h>
#include <conio.h>
#include <ctype.h>
#include <stdlib.h>
#include <string.h>

#define KERESENDO "csokolade"

enum {
    MINKAKAO=1,
    MAXKAKAO=100,
    MAXHOSSZ=100
};

int egesz(char s[]) {
    int i;
    i=(s[0]=='-' || s[0]=='+')?1:0;
    while(s[i]) {
        if(!isdigit(s[i]))return 0;
            ++i;
    }
    return 1;
}

int getline(char s[], int lim) {
    int i;
    char c;
    for(i=0;i<lim && (c=getchar())!='\n' && c!=EOF;++i)s[i]=c;
    s[i]='\0';
    while(c!='\n'&& c!=EOF)c=getchar();
    return i;
}

int jonev(char suti[]) {
    int i;

    for (i=0; suti[i]; ++i)
        if (!islower(suti[i]) && !isdigit(suti[i]))
            return 0;
    return 1;
}

int csokolades(char s[]) {
    if (strstr(s, KERESENDO))
        return 1;
    return 0;
}

void main(void) {
    char tmp[MAXHOSSZ+2];
    int csokis, vege=0, ok, bekert=0, szazalek, csokisdb=0, kakoosszeg=0;

    clrscr();

    do {
        ok=0;
        csokis=0;
        printf("Kerem adja meg az edesseg nevet (max. %d karakter)\n", MAXHOSSZ);
        do {
            if (!getline(tmp, MAXHOSSZ+1)) {
                printf("Ures sort utott, vege a bekeresnek.\n\n");
                vege=1;
                ok=1;
            } else if (strlen(tmp) > MAXHOSSZ)
                printf("Az edesseg neve max. %d karakterbol alljon.\n", MAXHOSSZ);
            else if (!jonev(tmp))
                printf("Az edesseg neve csak az angol ABC kisbetuit es szamokat tartalmazhat.\n");
            else {
                tmp[0] = toupper(tmp[0]);

                if (!csokolades(tmp))
                    printf("Az etelben sajnos nincs csokolade.\n");
                else {
                    printf("A(z) %s tartalmaz csokoladet.\n", tmp);
                    csokis=1;
                }

                ++bekert;
                ok=1;
            }
        } while(!ok);

        if (!vege && csokis) {
            ok=0;
            printf("Kerem adja meg az edesseg kakotartalmat (min. %d max. %d)\n", MINKAKAO, MAXKAKAO);
            do {
                if (!getline(tmp, 4))
                    printf("Nem adhat meg uras sort!\n");
                else if (strlen(tmp) > 3)
                    printf("A szazalek ertek max. 3 karakterbol allhat!\n");
                else if (!egesz(tmp))
                    printf("Nem egesz szamot adott meg!\n");
                else {
                    szazalek=atoi(tmp);

                    if (szazalek < MINKAKAO)
                        printf("A sutemeny minimum %d% kakaot tartalmazzon!\n", MINKAKAO);
                    else if (szazalek > MAXKAKAO)
                        printf("A sutemeny maximum %d% kakaot tartalmazhat!\n", MAXKAKAO);
                    else {
                        kakoosszeg+=szazalek;
                        ++csokisdb;
                        ok=1;
                    }
                }
            } while(!ok);
        }

    } while(!vege);

    if (bekert!=0) {
        printf("A sutemenyek atlagos csokolade tartalma %.2f% volt.\n", (double)kakoosszeg/bekert);
        printf("A sutemenyek kozul %.2f%% tartalmazott es %.2f%% nem tartalmazott csokoladet.\n", ((double)csokisdb*100)/bekert, 100-((double)csokisdb*100)/bekert);
    } else {
        printf("Egy edesseg adatait sem adta meg!\n");
    }

    getch();
}