#include<stdio.h>
#include<String.h>
#include<stdlib.h>
#include<ctype.h>

#define MAX 30
#define MIN 4

int beMenu(int *szam); //

int ellenor(char s[]); //
int szMenuEllenor(char s[]); // 

void kiNevResz(int hossz); //
void atalakit(char s[]); //

int getline(char s[], int lim); //
void reverse(char s[]);//
int egesz(char s[]);//

void main(void) {

	char nevBuff[MAX+1];
	int ki = 0,menupont;
	printf("Udv! Gepeljen be egy %i es %i intervallumba eso hosszusagu angol nevet\n",MIN,MAX);
	while ( ! ki ) {

		if ( ! getline(nevBuff,MAX + 1) ) {
			ki = 1;
		} else {
			if ( ! ellenor(nevBuff) ) {
				printf("Adja meg ujra!\n");
			} else {
				
				//A program tobbi resze:

				while ( ! beMenu(&menupont) );

				//A menupont aktivlsa:

				switch ( menupont ) {
				
				case 1 : {
					printf("Ennyi volt baby!!\n");
					break;
						 }
				case 2 : {
					//Ennl krem be a szmot, egy pill
					kiNevResz(nevBuff);
					break;
						 }
				case 3 : {
					//fordtva kiirom
					atalakit(nevBuff);
					break;
						 }
				case 4 : {
					printf("A nev hossza: %i\n",strlen(nevBuff));
						 }
				
				};

				printf("Udv! Gepeljen be egy %i es %i intervallumba eso hosszusagu angol nevet\n",MIN,MAX);
			}
		}
	}

}

void atalakit(char s[]) {
	reverse(s);

	printf("%s\n",s);
}

void kiNevResz( char nev[] ) {
	int szam,i,buffHossz,ki = 0;
	char buff[5];
	int hossz = strlen(nev);
	while ( !ki ) {
		printf("Adjon meg egy szamot!! 0 es %i kozott",hossz);

		if ( ! getline(buff,6) ) {
			printf("Ures sort nem adhat meg!!\n");
		} else {
			//ellenrzs ajj de elegem van belled input ellenrzs!!!

			buffHossz = strlen(buff);

			if ( buffHossz > 2 ) {
				printf("Tul hossz kar. lanc!!!\n");
			} else {
				if ( ! egesz(buff) ) {
					printf("Csak egesz szamokat adhat meg!!\n");
				} else {
					
					//Jhet a kiiras!!
					szam = atoi(buff);

					if ( szam > hossz ) {
						printf("Tul nagy szam!!\n");
					} else {

						for ( i = 0; i<hossz; i++ ) {
							if ( i < szam ) {
								printf("%c",nev[i]);
							}
						}

						printf("\n");

						ki = 1;
					}
				}
			}
		}
	}
}

int beMenu(int *szam) {
	char buff[5];
	int szamod;
	while ( 1 ) {
		printf("Irjon be egy szamot 1-4 ig\n");

		if ( ! getline(buff,2) ) {
			printf("Ures sort nem adhat meg!\n");
		} else {
			if ( (szamod = szMenuEllenor(buff)) ) {
				*szam = szamod;
				return 1;
			}
		}
	}

}

int szMenuEllenor(char s[]) {
	int hossz, szam;

	hossz = strlen(s);
	if (hossz > 1) {
		printf("Hibas szam!!\n");
		return 0;
	} else {
		if (!egesz(s)) {
			printf("Csak egesz szamot fogadok el!!\n");
			return 0;
		} else {
			szam = atoi(s);

			if (szam < 1 || szam > 4) {
				printf("Hibas menupont!!\n");
				return 0;
			} else {
				printf("Menupont aktivalva kapitany\n");
				return szam;
			}
		}
	}
}

int ellenor(char s[]) {
	int hossz,i = 0;

	hossz = strlen(s);

	if ( hossz > MAX || hossz < MIN ) {
		printf("A nev hosszusaganak a %i es %i intervallum kozott kell lennie\n",MAX,MIN);
		return 0;
	} else if (!isupper(s[i]) || !isalpha(s[i])) {
		printf("A nev elso betujenek nagynak kell lennie es angol betunek!!\n");
		return 0;
	} else {
		for ( i = 1; i<hossz; i++ )
			if (!islower(s[i]) || !isalpha(s[i])) {
				printf("A nev betui csak angol betuk lehetnek ES az elso kivetelevel, kisbetusek!!\n");
				return 0;
			}
	}

	printf("A nev elfogadva!!\n");
	return 1;
}

void reverse(char s[]) {
	char seged;
	int n,i,j;
	
	n = strlen(s);
	for ( i = 0; i<n/2; i++ ) {
		j = (n-i)-1;
		seged = s[j];
		s[j] = s[i];
		s[i] = seged;
	}
}

int getline(char s[],int lim){
 int i;
 char c;
 	for(i=0;i<lim && (c=getchar())!='\n' && c!=EOF;++i)s[i]=c;
 s[i]='\0';
 	while(c!='\n'&& c!=EOF)c=getchar();
 return i;
}

int egesz(char s[]){
	int i;
	i=(s[0]=='-' || s[0]=='+')?1:0;
	while(s[i]){
	 if(!isdigit(s[i]))return 0;
	 i++;
	}
	return 1;
}
