/*
 * Description : Program, ami megmondja, milyen nap lesz n nap mlva, azaz:
 *               Bemenet: Szerda
 *               n nap  : 5
 *               Kimenet: Htf
 *
 * Author      : Zoltn Furk
 *
 * Version     : 2011.01.22
 */
#include <stdio.h>
#include <ctype.h>
#include <string.h>
#include <stdlib.h>

/* a csutortok szo miatt */
enum {
    MAXHOSSZ = 9
};

int egesz(char s[]) {
    int i;
    i=(s[0]=='-' || s[0]=='+')?1:0;
    while(s[i]){
        if(!isdigit(s[i]))return 0;
        i++;
    }
    return 1;
}

int getline(char s[], int lim) {
    int i;
    char c;
    for(i=0;i<lim && (c=getchar())!='\n' && c!=EOF;++i)s[i]=c;
    s[i]='\0';
    while(c!='\n'&& c!=EOF)c=getchar();
    return i;
}

void main(void) {
    int i, ok=0, adottnap=-1, plusznap;
    char tmp[MAXHOSSZ+2], *napok[]={
                                     "Vasarnap",
                                     "Hetfo",
                                     "Kedd",
                                     "Szerda",
                                     "Csutortok",
                                     "Pentek",
                                     "Szombat"
                                    };

    clrscr();

    printf("Ez a program megmondja hogy milyen nap lesz 'n' nap mulva\n"
           "=========================================================\n"
           "Kerem adja meg milyen nap van ma:\n"
           "---------------------------------\n");
    do {
        if (!getline(tmp, MAXHOSSZ+1))
            printf("Nem lehet ures sort megadni!\n");
        else if (strlen(tmp) > MAXHOSSZ)
            printf("Maximum %d karaktert adhat meg!\n", MAXHOSSZ);
        else {
            if(strcmp(tmp,napok[0])==0)
                adottnap=0;
            else if(strcmp(tmp,napok[1])==0)
                adottnap=1;
            else if(strcmp(tmp,napok[2])==0)
                adottnap=2;
            else if(strcmp(tmp,napok[3])==0)
                adottnap=3;
            else if(strcmp(tmp,napok[4])==0)
                adottnap=4;
            else if(strcmp(tmp,napok[5])==0)
                adottnap=5;
            else if(strcmp(tmp,napok[6])==0)
                adottnap=6;
            else
                printf("Nem letezik %s nevu nap!\n", tmp);
        }
    } while (adottnap<0);

    printf("Kerem adja meg, hogy hany napot adjunk hozza:\n"
           "---------------------------------------------\n");
    do {
        if (!getline(tmp, 4))
            printf("Nem lehet ures sort megadni!\n");
        else if (strlen(tmp)>3)
            printf("Maximum 3 karaktert adhat meg!\n");
        else if(!egesz(tmp))
            printf("Nem egesz szamot adott meg!\n");
        else {
            plusznap=atoi(tmp);
            if(plusznap < 1)
                printf("1-nel kissebb szamot nem adhat meg!\n");
            else {
                switch ((adottnap + plusznap) % 7) {
                    case 1:
                        printf("%d nap mulva HETFO lesz!\n", plusznap);
                        break;
                    case 2:
                        printf("%d nap mulva KEDD lesz!\n", plusznap);
                        break;
                    case 3:
                        printf("%d nap mulva SZERDA lesz!\n", plusznap);
                        break;
                    case 4:
                        printf("%d nap mulva CSUTORTOK lesz!", plusznap);
                        break;
                    case 5:
                        printf("%d nap mulva PENTEK lesz!\n", plusznap);
                        break;
                    case 6:
                        printf("%d nap mulva SZOMBAT lesz!\n", plusznap);
                        break;
                    case 0:
                        printf("%d nap mulva VASARNAP lesz!\n", plusznap);
                        break;
                }
                ok=1;
            }
        }
    } while(!ok);

    getch();
}