/* 09_2.C: Hexadecimlis szmok konverzija. */

#define MAX 128		/* Az input puffer mrete. */
#include <stdio.h>
#include <ctype.h>
#include <string.h>

/* Visszaadja a beolvasott karaktersorozat hosszt. s tmbbe olvas,
   lim a karakterlnc maximlis hossza. Az s tmbnek teht legalbb
   lim+1 mretnek kell lennie. (A lnczr '\0' karakternek is kell
   hely.) */

int getline(char s[], int lim){
	int i,c;
	for(i=0; i<lim && (c=getchar())!=EOF && c!='\n'; ++i) s[i]=c;
	s[i]='\0';
	while(c!=EOF && c!='\n') c=getchar();
	return i; }

/* Az s karakterlncot 16 alap szmnak tekintve int-t konvertlja,
   s ez a rutin visszaadott rtke. */
int htoi(char s[]){
	int i, eredmeny=0;

	for(i=0; isxdigit(s[i]); ++i)
		if(isdigit(s[i])) eredmeny=eredmeny*16+s[i]-'0';
		else eredmeny=eredmeny*16+tolower(s[i])-'a'+10;
	return eredmeny; }

/* "Az s karakterlnc 16 alap szm-e?" krdsre ad logikai vlaszt
   a fggvny. */
int hszame(char s[]){
	int i;

	for(i=strlen(s)-1; i && isxdigit(s[i]); --i);
	if(isxdigit(s[i])) return 1; else return 0; }

void main(void){
	char szam[MAX+1];

	printf("\nAdjon meg egy hexadecimlis szmrendszerbeli szmot!\n");
	while(!getline(szam, MAX) || !hszame(szam));
	printf("Konvertlt eredmny: %d\n", htoi(szam)); }
