/* 10_1-4.C: rotl, rotr, tobbrotl s tobbrotr fggvnyek. */
#include <stdio.h>
#include <limits.h>
#define SZH sizeof(unsigned)*8	/* Bitek szma az unsigned tpusban. */

/* Egy bittel balra forgats: primitv vltozat.
   -------------------------  */
unsigned rotl3(unsigned szam){
	int i=szam;
	szam<<=1;
	if(i&0x8000) szam|=1;
    return szam; }

/* Ne hasznljunk tmeneti vltozkat, ha nem szksges! */
unsigned rotl2(unsigned szam){
	return (szam<<1)|(szam>>15); }
	/* A zrjelekre "elmletileg" nem lenne semmi szksg... */

/* Mdostsuk az elz vltozatot gy, hogy ne csak a TC2-nl mkdjn! */
unsigned rotl(unsigned szam){
	return(szam<<1 | szam>>SZH-1); }

/* Egy bittel jobbra forgats: az elzek felhasznlsval.
	-------------------------  */
unsigned rotr(unsigned szam){
	return (szam>>1)|(szam<<(SZH-1)); }

/* Tbb bittel balra forgats: primitv vltozat.
   --------------------------  */
unsigned tobbrotl2(unsigned szam, unsigned mennyivel){
	int i;
	for(i=0; i<mennyivel; ++i) szam=rotl(szam);
    return szam; }

/* A fejlesztett vltozat, rotl() mintjra */
unsigned tobbrotl(unsigned szam, unsigned mennyivel){
	return(szam<<mennyivel | szam>>(SZH-mennyivel)); }

/* Tbb bittel jobbra forgats:
   ---------------------------  */
unsigned tobbrotr(unsigned szam, unsigned mennyivel){
	return(szam>>mennyivel | szam<<(SZH-mennyivel)); }

/* Egy unsigned bitjeinek megjelentetse:
   -------------------------------------  */
void BitekKi(unsigned szam){
	unsigned i, maszk=INT_MIN;
	for(i=0; i<SZH; i++, szam<<=1)
		if(szam & maszk) putchar('1');
        else putchar('0'); }

void main(void){
	unsigned i=0x8001;
	printf("\nBitenknti forgats tesztelse:");
	printf("\n                             decimlis binris");
	printf("\n                            ---------------------------");
	printf("\nEredeti rtk:              %10u ", i);
	BitekKi(i);
	i=rotl(i);
	printf("\nEgy bittel balra forgatva:  %10u ", i);
	BitekKi(i);
	i=tobbrotr(i,4);
	printf("\nNgy bittel jobbra forgatva:%10u ", i);
	BitekKi(i);
	i=rotr(i);
	printf("\nEgy bittel jobbra forgatva: %10u ", i);
	BitekKi(i);
	i=tobbrotl(i,4);
	printf("\nNgy bittel balra forgatva: %10u ", i);
	BitekKi(i);
	putchar('\n'); }
