/*
 * Description : Haromszog
 *               A feladat leirasat lasd a feladat.txt fajlban.
 *
 * Author      : Zoltn Furk
 *
 * Version     : 2011.02.02
 */
#include <stdio.h>
#include <string.h>
#include <ctype.h>
#include <stdlib.h>
#include <math.h>
#include <conio.h>

enum {
    MAXHOSSZ=10
};

int getline(char s[], int lim) {
    int i;
    char c;
    for(i=0;i<lim && (c=getchar())!='\n' && c!=EOF;++i)s[i]=c;
    s[i]='\0';
    while(c!='\n'&& c!=EOF)c=getchar();
    return i;
}

int lebeg(char s[]){
    int i=0, kezd;
    while(isspace(s[i])) ++i;
    if(s[i]=='+'||s[i]=='-') ++i;
    kezd=i;
    while(isdigit(s[i])) ++i;
    if(s[i]=='.') ++i;
    while(isdigit(s[i])) ++i;
    if(i==kezd||kezd+1==i&&s[kezd]=='.') return 0;
    if(toupper(s[i])=='E'){
    ++i;
    if(s[i]=='+'||s[i]=='-')++i;
    if(!isdigit(s[i])) return 0;
    while(isdigit(s[i])) ++i;}
    if(isspace(s[i])||!s[i]) return 1;
    else return 0;
}

int megszerkeszthetoe(double a, double b, double c) {
    if (a+b>c && a+c>b && b+c>a)
        return 1;
    return 0;
}

void main(void) {
    char tmp[MAXHOSSZ+2];
    double a, b, c, s;
    int vege=0, ok;

    clrscr();

    do {
        printf("Kerem adja meg az 'a' oldalt:\n");
        ok=0;
        do {
            if (!getline(tmp, MAXHOSSZ+1)) {
                printf("Ures sort utott, vege a bekeresnek.\n\n");
                vege=1;
                ok=1;
            } else if (strlen(tmp) > MAXHOSSZ) {
                printf("Az 'a' oldal max. %d karakterbol alljon!\n", MAXHOSSZ);
            } else if (!lebeg(tmp))
                printf("Nem lebegopontos szamot adott meg!\n");
            else {
                a = atof(tmp);

                if (a < 0)
                    printf("Nem adhat meg 0 hosszt!\n");
                else
                    ok=1;
            }
        } while(!ok);

        if (!vege) {
            printf("Kerem adja meg a 'b' oldalt:\n");
            ok=0;
            do {
                if (!getline(tmp, MAXHOSSZ+1)) {
                    printf("Ures sort utott, vege a bekeresnek.\n");
                    vege=1;
                    ok=1;
                } else if (strlen(tmp) > MAXHOSSZ) {
                    printf("Az 'b' oldal max. %d karakterbol alljon!\n", MAXHOSSZ);
                } else if (!lebeg(tmp))
                    printf("Nem lebegopontos szamot adott meg!\n");
                else {
                    b = atof(tmp);

                    if (b < 0)
                        printf("Nem adhat meg 0 hosszt!\n");
                    else
                        ok=1;
                }
            } while(!ok);

            printf("Kerem adja meg a 'c' oldalt:\n");
            ok=0;
            do {
                if (!getline(tmp, MAXHOSSZ+1)) {
                    printf("Ures sort utott, vege a bekeresnek.\n");
                    vege=1;
                    ok=1;
                } else if (strlen(tmp) > MAXHOSSZ) {
                    printf("Az 'c' oldal max. %d karakterbol alljon!\n", MAXHOSSZ);
                } else if (!lebeg(tmp))
                    printf("Nem lebegopontos szamot adott meg!\n");
                else {
                    c = atof(tmp);

                    if (c < 0)
                        printf("Nem adhat meg 0 hosszt!\n");
                    else
                        ok=1;
                }
            } while(!ok);

            s = (a+b+c)/2;

            if (megszerkeszthetoe(a, b, c))
                printf("A haromszog megszerkesztheto:\n"
                       "Terulet: %.2f\n"
                       "Kerulet: %.2f\n", sqrt(s*(s-a)*(s-b)*(s-c)), a+b+c);
            else
                printf("A haromszog nem megszerkesztheto!\n");
        }
    } while(!vege);

    getch();
}