/*
 * Description : Lakcimvizsgalo
 *               A feladat leirasat lasd a feladat.jpg fajlban.
 *
 * Author      : Zoltn Furk
 *
 * Version     : 2011.01.25
 */
#include <stdio.h>
#include <string.h>
#include <ctype.h>
#include <conio.h>

enum {
    MAXHOSSZ=50
};
int getline(char s[], int lim) {
    int i;
    char c;
    for(i=0;i<lim && (c=getchar())!='\n' && c!=EOF;++i)s[i]=c;
    s[i]='\0';
    while(c!='\n'&& c!=EOF)c=getchar();
    return i;
}

int lakcim(char s[]) {
    int rossz=0, i, j, hazszamdb;

    if (!isdigit(s[0]) || !isdigit(s[1]) || !isdigit(s[2]) || !isdigit(s[3])) {
        printf("Az iranyitoszam csak egesz szamokbol allhat!\n");
        return 0;
    } else if (s[4] != ',') {
        printf("Az iranyitoszam elvalaszto \',\' karaktere rossz helyen van!\n");
        return 0;
    } else if (!isspace(s[5])) {
        printf("A , karakter utan nem space koevtkezik.\n");
        return 0;
    } else if (s[strlen(s)-1] != '.') {
        printf("A lakcimet a \'.\' karaterrel kell lezarni!\n");
        return 0;
    } else {
        for (i=5; isspace(s[i]); ++i)
            ;

        j=i;

        /* kozterulet elso szo */
        for (; !isspace(s[i]) && i<strlen(s); ++i)
            if (!isalpha(s[i]))
                rossz=1;

        if (rossz) {
            printf("A kozterulet elso szava nem megfelelo!\n");
            return 0;
        }

        for (; isspace(s[i]) && i<strlen(s); ++i)
            ;

        j=i;

        /* kozterulet masodik szo */
        for (; !isspace(s[i]); ++i)
            if (!isalpha(s[i]))
                rossz=1;

        /* vagy hazszam */
        if (rossz) {
            hazszamdb=0;

            for (; s[j]!='.'; ++j) {
                if (!isdigit(s[j])) {
                    printf("A kozterulet 2. szava vagy a hazszam nem megfelelo!\n");
                    return 0;
                } else {
                    ++hazszamdb;
                }
            }
            if (hazszamdb > 3) {
                printf("A hazszam maximum 3 szamjegybol allhat!\n");
                return 0;
            }
            return 1;
        }

        for (; isspace(s[i]) && i<strlen(s); ++i)
            ;

        j=i;

        /* kozterulet harmadik szo */
        for (; !isspace(s[i]); ++i)
            if (!isalpha(s[i]))
                rossz=1;

        /* vagy hazszam */
        if (rossz) {
            hazszamdb=0;

            for (; s[j]!='.'; ++j) {
                if (!isdigit(s[j])) {
                    printf("A kozterulet 3. szava vagy a hazszam nem megfelelo!\n");
                    return 0;
                } else {
                    ++hazszamdb;
                }
            }
            if (hazszamdb > 3) {
                printf("A hazszam maximum 3 szamjegybol allhat!\n");
                return 0;
            }
            return 1;
        }

        for (; isspace(s[i]) && i<strlen(s); ++i)
            ;

        hazszamdb=0;

        for (; s[i]!='.'; ++i) {
            if (!isdigit(s[i])) {
                printf("A kozterulet 3. szava vagy a hazszam nem megfelelo!\n");
                return 0;
            } else {
                ++hazszamdb;
            }
        }
        if (hazszamdb > 3) {
            printf("A hazszam maximum 3 szamjegybol allhat!\n");
            return 0;
        }
        return 1;
    }
    return 1;
}

void main(void) {
    char tmp[MAXHOSSZ+2];
    int ok;

    /*clrscr();*/

    printf("Kerem adja meg a lakcimet:\n"
           "--------------------------\n");
    do {
        if(!getline(tmp, MAXHOSSZ+2))
            printf("Nem lehet ures sort megadni!\n");
        else if (strlen(tmp) > MAXHOSSZ)
            printf("A megadott karaktersorozat tul hosszu!\n");
        else
            ok=lakcim(tmp);
    } while (!ok);

    printf("A megadott lakcim:\n"
           "------------------\n"
           "%s\n", tmp);

    getch();
}