/*
 * Description : Karakterszamlalo
 *               A feladat leirasat lasd a feladat.jpg fajlban.
 *
 * Author      : Zoltn Furk
 *
 * Version     : 2011.01.25
 */
#include <stdio.h>
#include <ctype.h>
#include <string.h>
#include <conio.h>

enum {
    MINHOSSZ=10,
    MAXHOSSZ=20
};

int getline(char s[], int lim) {
    int i;
    char c;
    for(i=0;i<lim && (c=getchar())!='\n' && c!=EOF;++i)s[i]=c;
    s[i]='\0';
    while(c!='\n'&& c!=EOF)c=getchar();
    return i;
}

void rendez(char s[]){
    int i, j;
    char temp;

    for (i=0; s[i]; ++i)
        for (j=0; j<strlen(s) - 1; ++j)
            if(s[j] > s[j + 1]) {
                temp = s[j];
                s[j] = s[j + 1];
                s[j + 1] = temp;
            }
}

void main(void) {
    char tmp[MAXHOSSZ+2];

    int i, vege=0, egyeb=0;
    int kisbetuk[26];

    clrscr();

    printf("Kerem adjon meg egy maximum %d, minimum %d  hosszu karaktersorozatot:\n"
           "---------------------------------------------------------\n", MAXHOSSZ, MINHOSSZ);
    do {
        egyeb = 0;
        for(i=0; i<26; ++i)
            kisbetuk[i]=0;

        if (!getline(tmp, MAXHOSSZ+1))
            printf("Nem lehet ures sort megadni!\n");
        else if (strlen(tmp) > MAXHOSSZ)
            printf("Maximum %d karaktert adjon meg!\n", MAXHOSSZ);
        else if (strlen(tmp) < MINHOSSZ)
            printf("Minimum %d karaktert adjon meg!\n", MINHOSSZ);
        else {
            for (i=0; tmp[i]; ++i) {
                if (islower(tmp[i]))
                    ++kisbetuk[tmp[i]-'a'];
                else
                    ++egyeb;
            }

            if (!egyeb)
                vege=1;
            else
                printf("A karatkerek csak angol kisbetuk lehetnek!\n");
        }
    } while (!vege);

    printf("\nA kisbetuk szama:\n"
           "-----------------\n");

    for(i=0; i<26; ++i)
        if(kisbetuk[i] != 0)
            printf("'%c' karakterbol %d darab volt a bementen.\n", i+'a', kisbetuk[i]);

    rendez(tmp);

    printf("A tomb tartalma rendezetten kiratva:\n"
           "%s\n"
           "hossza: %d\n", tmp, strlen(tmp));
    getch();
}