/*
 * Description : Kis nagybetu konvertalo
 *               A feladat leirasat lasd a feladat.txt fajlban.
 *
 * Author      : Zoltn Furk
 *
 * Version     : 2011.01.25
 */
#include <stdio.h>
#include <string.h>
#include <conio.h>
#include <ctype.h>

enum {
    MAXHOSSZ=100
};

 int getline(char s[], int lim) {
    int i;
    char c;
    for(i=0;i<lim && (c=getchar())!='\n' && c!=EOF;++i)s[i]=c;
    s[i]='\0';
    while(c!='\n'&& c!=EOF)c=getchar();
    return i;
}

void main(void) {
    char tmp[MAXHOSSZ+2];
    int i, osszeg=0, sordb=0, szamdb, vege=0;;

    clrscr();

    do {
        printf("Kerem adjon meg egy karaktersorozatot:\n"
               "--------------------------------------\n");
        szamdb=0;
        if (!getline(tmp, MAXHOSSZ+1)) {
            printf("Ures sort utott, vege a bekeresnek.\n\n");
            vege=1;
        } else if (strlen(tmp) > MAXHOSSZ)
            printf("Maximum %d karaktert adjon meg!\n", MAXHOSSZ);
        else {

            for (i=0; tmp[i]; ++i) {
                if (isupper(tmp[i]))
                    tmp[i] = tolower(tmp[i]);
                else if (islower(tmp[i]))
                    tmp[i] = toupper(tmp[i]);
                else if (isspace(tmp[i]))
                    tmp[i] = ' ';
                else if (isdigit(tmp[i]))
                    ++szamdb;
            }

            printf("%s\n%d db szam volt benne.\n\n", tmp, szamdb);
            osszeg+=strlen(tmp);
            ++sordb;
        }
    } while(!vege);

    if (sordb>0)
        printf("A sorok atlagos hossza %.2f volt.\n", (double)osszeg/sordb);
    else
        printf("Egy sort sem adott meg.\n");

    getch();
}