/*
 * Description : ABC sorrend
 *               A feladat leirasat lasd a feladat.jpg fajlban.
 *
 * Author      : Zoltn Furk
 *
 * Version     : 2011.01.30
 */
#include <stdio.h>
#include <conio.h>
#include <ctype.h>
#include <string.h>

enum {
    MAXHOSSZ=24
};

int getline(char s[], int lim) {
    int i;
    char c;
    for(i=0;i<lim && (c=getchar())!='\n' && c!=EOF;++i)s[i]=c;
    s[i]='\0';
    while(c!='\n'&& c!=EOF)c=getchar();
    return i;
}

int jokaraktersorozat(char szoveg[]) {
    int i;

    for (i=0; szoveg[i]; ++i)
        if (!isalpha(szoveg[i]))
            return 0;
    return 1;
}

void kisbetuve(char szoveg[]) {
    int i;

    for (i=0; szoveg[i]; ++i)
        szoveg[i] = tolower(szoveg[i]);
}

void rendez(char szoveg[]) {
    int i, j;
    char tmp;

    for (i=0; szoveg[i]; ++i) {
        for (j=0; j<strlen(szoveg)-1; ++j) {
            if (szoveg[j] < szoveg[j+1]) {
                tmp = szoveg[j];
                szoveg[j] = szoveg[j+1];
                szoveg[j+1] = tmp;
            }
        }
    }
}

void egykarakterkiiratas(char szoveg[]) {
    int i;

    for (i=0; szoveg[i]; ++i)
        if (szoveg[i]!=szoveg[i+1])
            printf("%c", szoveg[i]);
    printf("\n");
}

void main(void) {
    char tmp[MAXHOSSZ+2];
    int vege=0;

    clrscr();

    do {
        printf("Kerem adjon meg max. %d hosszu karaktersoroatokat:\n", MAXHOSSZ);

        if (!getline(tmp, MAXHOSSZ+1)) {
            printf("Ures sort utott, vege a bekeresnek.\n");
            vege=1;
        } else if (strlen(tmp) > MAXHOSSZ)
            printf("A karaktersorozat max. %d hosszu lehet!\n", MAXHOSSZ);
        else if (!jokaraktersorozat(tmp))
            printf("A szoveg csak az angol ABC karaktereit tartalmazhatja!\n");
        else {
            kisbetuve(tmp);
            rendez(tmp);
            egykarakterkiiratas(tmp);
        }
    } while(!vege);

    getch();
}