/*
 * Description : Futoverseny
 *               A feladat leirasat lasd a feladat.jpg fajlban.
 *
 * Author      : Zoltn Furk
 *
 * Version     : 2011.01.30
 */
#include <stdio.h>
#include <conio.h>
#include <ctype.h>
#include <string.h>
#include <stdlib.h>

enum {
    MINPERC=15,
    MAXPERC=60,
    MAXSZAMDB=15,
    VERSENYTAV=10,
    MAXSZAMHOSSZ=4
};

int getline(char s[], int lim) {
    int i;
    char c;
    for(i=0;i<lim && (c=getchar())!='\n' && c!=EOF;++i)s[i]=c;
    s[i]='\0';
    while(c!='\n'&& c!=EOF)c=getchar();
    return i;
}

int lebeg(char s[]) {
    int i=0, kezd;
    while(isspace(s[i])) ++i;
    if(s[i]=='+'||s[i]=='-') ++i;
    kezd=i;
    while(isdigit(s[i])) ++i;
    if(s[i]=='.') ++i;
    while(isdigit(s[i])) ++i;
    if(i==kezd||kezd+1==i&&s[kezd]=='.') return 0;
    if(toupper(s[i])=='E'){
    ++i;
    if(s[i]=='+'||s[i]=='-')++i;
    if(!isdigit(s[i])) return 0;
    while(isdigit(s[i])) ++i;}
    if(isspace(s[i])||!s[i]) return 1;
    else return 0;
}

void rendezes(double eredmenyek[], int eredmenydb) {
    double tmp;
    int i, j;

    for (i=0; i<eredmenydb; ++i) {
        for (j=0; j<eredmenydb-1; ++j) {
            if (eredmenyek[j] > eredmenyek[j+1]) {
                tmp = eredmenyek[j];
                eredmenyek[j] = eredmenyek[j+1];
                eredmenyek[j+1] = tmp;
            }
        }
    }
}

void main(void) {
    char tmp[MAXSZAMHOSSZ+2];
    int vege=0, ok, bekert=0;
    double sebesseg_osszeg=0, eredmenyek[MAXSZAMDB], atlag;

    clrscr();

    do {
        printf("Kerem adja meg a(z) %d. futo eredmenyet:\n", bekert+1);
        ok=0;
        do {
            if (!getline(tmp, MAXSZAMHOSSZ+1)) {
                printf("Ures sort utott, vege a bekeresnek.\n\n");
                vege=1;
                ok=1;
            } else if (strlen(tmp) > MAXSZAMHOSSZ)
                printf("A szam max. %d hosszu lehet!\n", MAXSZAMHOSSZ);
            else if (!lebeg(tmp))
                printf("Nem lebegopontos szamot adott meg!\n");
            else {
                eredmenyek[bekert] = atof(tmp);

                if (eredmenyek[bekert] < MINPERC)
                    printf("A futas hossza min. %d perc legyen!\n", MINPERC);
                else if (eredmenyek[bekert] > MAXPERC)
                    printf("A futas hossza max. %d perc legyen!\n", MAXPERC);
                else {
                    sebesseg_osszeg+=eredmenyek[bekert];
                    ++bekert;
                    ok=1;
                }
            }
        } while(!ok);

        if (bekert == MAXSZAMDB) {
            printf("Bekertuk %d futo eredmenyet, vege a bekeresnek!\n\n", MAXSZAMDB);
            vege=1;
        }
    } while(!vege);

    if (bekert != 0) {
        rendezes(eredmenyek, bekert);

        atlag = sebesseg_osszeg/(bekert*VERSENYTAV);

        printf("A leggyorsabb futo atlagsebessege: %.2f perc/km.\n"
               "A leglassabb futo atlagsebessege : %.2f perc/km.\n", eredmenyek[0]/VERSENYTAV, eredmenyek[bekert-1]/VERSENYTAV);

        printf("A futok atlagsebessege %.2f perc/km volt.\n"
               "Az atlag %.2f perc/km -el gyorsabb mint a leglassabb.\n"
               "Az atlag %.2f perc/km -el lassabb mint a leggyorsabb.\n", atlag, (eredmenyek[bekert-1]/VERSENYTAV)-atlag, atlag-(eredmenyek[0]/VERSENYTAV));
    } else {
        printf("Egy futo eredmenyet sem adtak meg!\n");
    }

    getch();
}